void pi_getasyncevent(unsigned long temp){
u32 axis,event,i;
unsigned long high,low;
        spin_lock(pi_lock);
        // safe in here
        // get the axis which interrupted
        pi_send_cmd(PI_GET_INTERRUPT_AXIS);
        axis=pi_read_data();
        printk("PIDEBUG axis=%x\n",axis);
        pi_stage.event_index++;
        for(i=0;i<pi_stage.naxis;i++){
		event=0;
                if(axis & (1<<i)){
                        //get event
                        pi_send_cmd(PI_GET_EVENT_STATUS | (i<<8));
                        event=pi_read_data();
                        // we have all we need, save and quit
                        pi_stage.events[pi_stage.event_head].index      =pi_stage.event_index;
                        pi_stage.events[pi_stage.event_head].axis       =pi_stage.event_index;
                        pi_stage.events[pi_stage.event_head].ts_high    =high;
                        pi_stage.events[pi_stage.event_head].ts_low     =low;
                        pi_stage.events[pi_stage.event_head].event      =event;

                        // inc the head to the next place and take care of collisions
                        pi_stage.event_head++;
                        if(pi_stage.event_head>=PI_N_EVENTS){
                                pi_stage.event_head=0;
                                }
                        if(pi_stage.event_head==pi_stage.event_tail){
                                // head and tail collided
                                pi_stage.event_tail++;
                                if(pi_stage.event_tail>=PI_N_EVENTS){
                                        pi_stage.event_tail=0;
                                        }
                                printk("PI: ring buffer collision\n");
                                }
                        printk("*:");
                        }

                        // reset event
                pi_send_cmd(PI_RESET_EVENT_STATUS);
                pi_send_data(0);
                rdtsc(high,low);
                printk("PIDEBUG: i=%d, event=%x \n",i,event);
                }
        pi_send_cmd(PI_CLEAR_INTERRUPT);
        spin_unlock(pi_lock);
        }

